/*
Main.h
Written by Matthew Fisher

Main.h is included by all source files and includes every header file in the correct order.
*/
#pragma once

//
// Config.h includes a series of #defines used to control compiling options
//
#include "Config.h"

//
// Engine.h includes everything that rarely changes between applications, such as vector/Matrix4 libraries,
// OpenGL/DirectX graphics devices, software rasterizers, etc.
//
#include "Engine.h"

#include "ImageSegmenter.h"

#include "Graph\Edge.h"
#include "Graph\Node.h"
#include "Graph\Walk.h"
#include "Graph\Graph.h"

#include "Kernel\NodeKernel.h"
#include "Kernel\EdgeKernel.h"
#include "Kernel\WalkKernel.h"
#include "Kernel\RootedGraphKernel.h"
#include "Kernel\RootedGraphKernelEnumerateWalks.h"
#include "Kernel\RootedGraphKernelDynamicProgramming.h"
#include "Kernel\GraphKernel.h"

#include "App.h"
